local hasjob = false
local incepejob = {1321.0168457031,4314.4794921875,38.145561218262}
local vindepesti = {1309.1414794922,4362.072265625,41.544342041016}
local barca = {1292.9351806641,4223.4609375,29.731874465942}
local locpescuit = {1039.2467041016,3945.4182128906,29.632402420044}

RegisterNetEvent("br-npc:client:pescar:incepejob")
AddEventHandler("br-npc:client:pescar:incepejob", function()
    hasjob = true
    tvRP.notify("Te-ai angajat cu succes!")
end)

RegisterNetEvent("br-npc:client:pescar:terminajob")
AddEventHandler("br-npc:client:pescar:terminajob", function()
    hasjob = false
end)

local function DrawImage3D(name1, name2, x, y, z, width, height, rot, r, g, b, alpha) 
    local onScreen, _x, _y = World3dToScreen2d(x, y, z)
    local dist = #(GetGameplayCamCoords() - vector3(x, y, z))
    local ped = PlayerPedId()
    if onScreen then
        local width = (1 / dist) * width
        local height = (1 / dist) * height
        local fov = (1 / GetGameplayCamFov()) * 100
        width = width * fov
        height = height * fov
        local CoordFrom = GetEntityCoords(ped, true)
        local RayHandle = StartShapeTestRay(CoordFrom.x, CoordFrom.y, CoordFrom.z, x, y, z, -1, ped, 0)
        local _, _, _, _, object = GetShapeTestResult(RayHandle)
        if not object or object == 0 then
            DrawSprite(name1, name2, _x, _y, width, height, rot, r, g, b, alpha)
        end
    end
end

local function drawText(text, x, y, scale, r, g, b)
    SetTextFont(0)
    SetTextCentre(1)
    SetTextProportional(0)
    SetTextScale(scale, scale)
    SetTextDropShadow(30, 5, 5, 5, 255)
    SetTextEntry("STRING")
    SetTextColour(r, g, b, 255)
    AddTextComponentString(text)
    DrawText(x, y)
end

local function DrawText3D(x, y, z, text, scl) 
    local onScreen, _x, _y = World3dToScreen2d(x, y, z)
    local px, py, pz = table.unpack(GetGameplayCamCoords())
    local dist = GetDistanceBetweenCoords(px, py, pz, x, y, z, 1)
    local scale = (1 / dist) * scl
    local fov = (1 / GetGameplayCamFov()) * 100
    scale = scale * fov
    if onScreen then
        SetTextScale(0.0 * scale, 1.1 * scale)
        SetTextFont(0)
        SetTextProportional(1)
        SetTextColour(255, 255, 255, 255)
        SetTextDropshadow(0, 0, 0, 0, 255)
        SetTextEdge(2, 0, 0, 0, 150)
        SetTextDropShadow()
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x, _y)
    end
end

function pescuieste()
    local ped = PlayerPedId()
    TaskStartScenarioInPlace(ped, "WORLD_HUMAN_STAND_FISHING", 0, true)
    exports['progressbar']:Progress({
        name = "pescuit",
        duration = 60000, -- Durata în milisecunde (60 secunde)
        label = "Pescuiesti...",
        useWhileDead = false,
        canCancel = true,
        controlDisables = {
            disableMovement = true,
            disableCarMovement = true,
            disableMouse = false,
            disableCombat = true
        },
        animation = {
            animDict = "amb@world_human_stand_fishing@base",
            anim = "base"
        },
        prop = {
            model = "prop_fishing_rod_01",
            bone = 28422,
            coords = vector3(0.15, 0.0, 0.0), -- Ajustat pentru poziționare corectă
            rotation = vector3(0.0, 50.0, 0.0) -- Rotește undița pentru a fi în fața jucătorului
        }
    }, function(cancelled)
        if cancelled then
            ClearPedTasks(ped)
        else
            vRPserver.daiPesti({})
            tvRP.notify("Ai prins un pește!")
        end
        isFishing = false -- Permite repornirea pescuitului după anulare
    end)
    isFishing = true -- Blochează alte acțiuni în timpul pescuitului
end

RegisterCommand("ancora", function(source)
    local ped = PlayerPedId()
    if IsPedInAnyBoat(ped) then
        local boat = GetVehiclePedIsIn(ped)
        if GetPedInVehicleSeat(boat, -1) == ped then
            if GetEntitySpeed(ped) <= 10 / 3.6 then -- KM/H
                if IsBoatAnchoredAndFrozen(boat) then
                    SetBoatAnchor(boat, false)
                    SetBoatFrozenWhenAnchored(boat, false)
                    SetForcedBoatLocationWhenAnchored(boat, false)
                    tvRP.notify("Ancora a fost ridicata")
                else
                    if CanAnchorBoatHere(boat) then
                        SetBoatAnchor(boat, true)
                        SetBoatFrozenWhenAnchored(boat, true)
                        SetForcedBoatLocationWhenAnchored(boat, true)
                        tvRP.notify("Ancora a fost aruncata")
                    else
                        tvRP.notify("Nu poti pune ancora aici", 2)
                    end
                end
            else
                tvRP.notify("Ai prea mare viteza pentru a pune ancora", 2)
            end
        end
    end
end, false)

CreateThread(function()
    local ticks = 1000
    while true do
        ped = PlayerPedId()
        if hasjob then
            if #(GetEntityCoords(ped) - vector3(locpescuit[1], locpescuit[2], locpescuit[3])) <= 400.0 then
                ticks = 1
                DrawMarker(1, locpescuit[1], locpescuit[2], locpescuit[3], 0, 0, 0, 0, 0, 0, 200.4, 200.4, 1.4, 253, 190, 34, 165, 0, 0, 2, 1, 0, 1, 0, 1)
                if #(GetEntityCoords(ped) - vector3(locpescuit[1], locpescuit[2], locpescuit[3])) <= 100.4 then
                    drawText("~w~[~HUD_COLOUR_NET_PLAYER13~E~w~] pentru a pescui", 0.5, 0.9, 0.4, 255, 255, 255)
                    if IsControlJustPressed(1, 51) and not IsPedInAnyVehicle(ped, false) and not IsPedSwimming(ped) and not isFishing then
                        pescuieste()
                    end
                end
            end
        end
        -- Text de anulare
        if isFishing then
            drawText("~w~[~HUD_COLOUR_NET_PLAYER13~ESC~w~] pentru a anula", 0.5, 0.95, 0.4, 255, 255, 255)
        end
        Wait(ticks)
        ticks = 1000
    end
end)

CreateThread(function()
    while true do
        Wait(0)
        if isFishing and IsControlJustPressed(1, 322) then -- ESC key
            ClearPedTasks(PlayerPedId())
            tvRP.notify("Ai anulat animatia")
            isFishing = false -- Permite repornirea pescuitului după anulare
        end
    end
end)
